source globals.tcl

proc CreateWindow { parent name } {
    if { $name == {} } {
	return false
    }

    if { $parent == {} } {
	set root .$name
	set rootui ".[subst $name]ui"
    } elseif { $parent == "." } {
	set root .$name
	set rootui ".[subst $name]ui"
    } else {
	set root $parent.$name
	set rootui "$parent.[subst $name]ui"
    }

    set varWindow $name

    bind $root.toglarea <KeyPress> "$varWindow handleKeyboard %K 0 %x %y"
    #bind $root.toglarea <KeyRelease> "$varWindow handleKeyboard %K 1 %x %y"
    bind $root.toglarea <ButtonPress> "$varWindow handleMouseButton %b 0 %x %y"
    bind $root.toglarea <ButtonRelease> "$varWindow handleMouseButton %b 1 %x %y"
    bind $root.toglarea <B1-Motion> "$varWindow handleMouseMotion 1 %x %y"
    bind $root.toglarea <B2-Motion> "$varWindow handleMouseMotion 2 %x %y"
    bind $root.toglarea <B3-Motion> "$varWindow handleMouseMotion 3 %x %y"

    wm minsize . 1 1
    wm maxsize . 640 480
    #wm maxsize . 1000 1000
    wm resizable . 1 1
  
    focus $root.toglarea

    pack $root.toglarea -side left -fill both -expand 1
    pack $root -fill both -expand 1

    toplevel $rootui

    CreateMenuBar $rootui menubar \
	    [list \
	      [list file File left \
	        [list \
	          [list command "w: Write" "$varWindow handleWrite"] \
	          [list command "esc: Exit" exit] \
                ] \
	      ] \
	      [list options Options left \
	        [list \
	          [list checkbutton "e: Display Events" $varWindow displayEvents setDisplayEvents] \
		] \
	      ] \
	      [list help Help right \
	        [list \
	          [list command "L Button - Places first vertex then draws lines to subsequent vertices" ""] \
	          [list command "M Button - Closes the current polygon" ""] \
	          [list command "R Button - Write SLIDE file; Exit program" ""] \
                ] \
	      ] \
	    ]

    CreateToolBar $rootui readout1 \
	    [list \
	      [list text "Frames Per Second:  "] \
	      [list text "Requested = "] \
	      [list textOut $varWindow framesPerSecondRequested] \
	    ]
    CreateToolBar $rootui readout2 \
	    [list \
	      [list text "Update Time = "] \
	      [list textOut $varWindow updateTime] \
	      [list text "Render Time = "] \
	      [list textOut $varWindow renderTime] \
	    ]

    pack $rootui.menubar $rootui.readout1 $rootui.readout2 -side top -fill x

    return true
}



